
' USAGE
' Dim Kb_OnOff As New KeyboardOnOff()
' Kb_OnOff.SetKeyboardHook()
' Kb_OnOff.ReleaseKeyboardHook()

Imports System.Runtime.InteropServices
Imports System.Reflection.Assembly

Friend Class KeyboardOnOff

    Private Const HC_ACTION As Integer = 0
    Private Const WH_KEYBOARD_LL As Integer = 13
    Private Const WM_KEYDOWN As Integer = &H100
    Private Const WM_KEYUP As Integer = &H101
    Private Const WM_SYSKEYDOWN As Integer = &H104
    Private Const WM_SYSKEYUP As Integer = &H105

    Private Structure KBDLLHOOKSTRUCT
        Public vkCode As Integer
        Public scanCode As Integer
        Public flags As Integer
        Public time As Integer
        Public dwExtraInfo As Integer
    End Structure

    'Private Declare Auto Function GetModuleHandle Lib "kernel32" (ByVal lpModuleName As String) As IntPtr

    Private Declare Auto Function SetWindowsHookEx Lib "user32" (ByVal idHook As Integer, _
                                                                 ByVal lpfn As LowLevelKeyboardProcDelegate, _
                                                                 ByVal hmod As Integer, _
                                                                 ByVal dwThreadId As UInteger) As Integer

    Private Declare Auto Function CallNextHookEx Lib "user32" (ByVal hHook As Integer, _
                                                               ByVal nCode As Integer, _
                                                               ByVal wParam As Integer, _
                                                               ByVal lParam As KBDLLHOOKSTRUCT) As Integer

    Private Declare Auto Function UnhookWindowsHookEx Lib "user32" (ByVal hHook As Integer) As Integer

    Private Delegate Function LowLevelKeyboardProcDelegate(ByVal nCode As Integer, _
                                                           ByVal wParam As Integer, _
                                                           ByRef lParam As KBDLLHOOKSTRUCT) As Integer

    Private KeyboardHook As Integer

    Private KeyboardHookDelegate As LowLevelKeyboardProcDelegate = AddressOf LowLevelKeyboardProc

    Private Function LowLevelKeyboardProc(ByVal nCode As Integer, _
                                          ByVal wParam As Integer, _
                                          ByRef lParam As KBDLLHOOKSTRUCT) As Integer
        If (nCode = HC_ACTION) Then

            If wParam = WM_KEYDOWN Or _
               wParam = WM_SYSKEYDOWN Or _
               wParam = WM_KEYUP Or _
               wParam = WM_SYSKEYUP Then

                If KeyboardEnabled Then
                    DisableCounter = 0
                Else
                    If wParam = WM_KEYUP Then
                        TestPassword(lParam.vkCode)
                    End If
                    Return 1
                End If
            End If
        End If
        Return CallNextHookEx(KeyboardHook, nCode, wParam, lParam)
    End Function

    Private WithEvents timer1 As Timer = New Timer
    Private Password As String = "PASS"
    Private ComposingSequence As String = ""

    Private Sub TestPassword(ByVal code As Int32)
        If Password.Length = 0 Then Return
        ComposingSequence += Char.ToUpper(Convert.ToChar(code))
        ComposingSequence = Strings.Right(ComposingSequence, Password.Length)
        If ComposingSequence = Password Then
            DisableCounter = -1
        Else
            timer1.Interval = 2000
            timer1.Stop()
            timer1.Start()
        End If
    End Sub

    Private Sub timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles timer1.Tick
        timer1.Stop()
        ComposingSequence = ""
    End Sub

    Friend Sub SetKeyboardHook()
        'KeyboardHook = SetWindowsHookEx(WH_KEYBOARD_LL, _
        '                                KeyboardHookDelegate, _
        '                                Marshal.GetHINSTANCE(GetExecutingAssembly.GetModules()(0)).ToInt32, _
        '                                0)

        'Dim curProcess As Process = Process.GetCurrentProcess()
        'Dim curModule As ProcessModule = curProcess.MainModule
        'curModule.GetHashCode()
        'KeyboardHook = SetWindowsHookEx(WH_KEYBOARD_LL, _
        '                                KeyboardHookDelegate, _
        '                                GetModuleHandle(curModule.ModuleName).ToInt32, _
        '                                0)

        KeyboardHook = SetWindowsHookEx(WH_KEYBOARD_LL, _
                                        KeyboardHookDelegate, _
                                        Nothing, _
                                        0)
    End Sub

    Friend Sub ReleaseKeyboardHook()
        UnhookWindowsHookEx(KeyboardHook)
    End Sub

    Friend Sub SetPassword(ByVal s As String)
        Password = s.ToUpper
    End Sub

End Class



