﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        Load_INI()
        Me.Visible = False
        SetParams()
        TestIfStartupLinkExists()
        Mouse_OnOff.SetMouseHook()
        Keyboard_OnOff.SetKeyboardHook()
        ShowInTaskbar = False
        InitTrayIcon()
        Refresh()
        Opacity = 1
        EventsAreEnabled = True
        Timer1.Interval = 100
        Timer1.Start()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        If Me.WindowState <> FormWindowState.Minimized Then
            e.Cancel = True
            Me.WindowState = FormWindowState.Minimized
            Me.Hide()
            If chk_NoMessages.Checked = False Then
                sysTrayIcon.ShowBalloonTip(6000, _
                                           "The application is not closed,", _
                                           "it has been moved to the tray area." & vbCr & _
                                           "Right click the Icon to exit.", _
                                           ToolTipIcon.Info)
            End If
            Return
        End If
        Form2.Close()
        sysTrayIcon.Dispose()
        Mouse_OnOff.ReleaseMouseHook()
        Keyboard_OnOff.ReleaseKeyboardHook()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub btn_ClearIconCache_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ClearIconCache.Click
        Try
            Process.Start("ie4uinit.exe", "-show")
        Catch
            MsgBox("Can not find the file ""ie4uinit.exe""" + vbCrLf + _
                   "Maybe this command is working on Windows10 only.")
        End Try
    End Sub

    Private Sub btn_OpenStartupFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_OpenStartupFolder.Click
        Dim StartupFolder As String = Environment.GetFolderPath(Environment.SpecialFolder.Startup)
        Process.Start(StartupFolder)
    End Sub

    Private Sub chk_StartAutomatically_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_StartAutomatically.CheckedChanged
        If Not EventsAreEnabled Then Return
        If chk_StartAutomatically.Checked Then
            CreateShortcutInStartUpFolder("Theremino_WatchDog")
        Else
            RemoveShortcutFromStartUpFolder("Theremino_WatchDog")
        End If
    End Sub

    Private Sub TestIfStartupLinkExists()
        Dim StartupFolder As String = Environment.GetFolderPath(Environment.SpecialFolder.Startup)
        If IO.File.Exists(StartupFolder + "\Theremino_WatchDog.lnk") Then
            chk_StartAutomatically.Checked = True
        Else
            chk_StartAutomatically.Checked = False
        End If
    End Sub

    Private Sub txt_CountTime_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_CountTime.TextChanged
        SetParams()
    End Sub
    Private Sub txt_Password_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_Password.TextChanged
        SetParams()
    End Sub
    Private Sub txt_MouseSequence_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_MouseSequence.TextChanged
        SetParams()
    End Sub
    Private Sub SetParams()
        DisableTime = CSng(Val(txt_CountTime.Text))
        Keyboard_OnOff.SetPassword(txt_Password.Text)
        Mouse_OnOff.SetMouseSequence(txt_MouseSequence.Text)
    End Sub


    ' ================================================================
    '  SYS TRAY ICON
    ' ================================================================
    Private WithEvents sysTrayIcon As NotifyIcon
    Private WithEvents sysTrayMenu As ContextMenuStrip

    Private Sub InitTrayIcon()
        sysTrayMenu = New ContextMenuStrip()
        With sysTrayMenu
            .Items.Add("Properties", Nothing, AddressOf OnProps)
            .Items.Add("Exit", Nothing, AddressOf OnExit)
        End With

        sysTrayIcon = New NotifyIcon
        With sysTrayIcon
            .Text = "Theremino WatchDog"
            .ContextMenuStrip = sysTrayMenu
            .Icon = My.Resources.Watchdog3
            .Visible = True
        End With
    End Sub

    Private Sub OnProps(ByVal sender As Object, ByVal e As EventArgs)
        Opacity = 0
        Me.Show()
        WindowState = FormWindowState.Normal
        Opacity = 1
        Me.Focus()
    End Sub

    Private Sub OnExit(ByVal sender As Object, ByVal e As EventArgs)
        WindowState = FormWindowState.Minimized
        Close()
    End Sub

    Private Sub sysTrayIcon_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles sysTrayIcon.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            DisableCounter = DisableTime
            DisableAll()
        End If
    End Sub

    Private Function TestEnableMethods() As Boolean
        Return txt_Password.Text <> "" Or _
               txt_MouseSequence.Text <> "" Or _
               chk_EnableNose.Checked
    End Function

    ' ================================================================
    '  Keyboard and Mouse disabler
    ' ================================================================
    Private Mouse_OnOff As New MouseOnOff()
    Private Keyboard_OnOff As New KeyboardOnOff()
    Private DisableTime As Single = 60

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '
        If DisableCounter < 0 Then
            DisableCounter = 0
            EnableAll()
        End If
        '
        If DisableTime < 5 Or TestEnableMethods() = False Then
            If lbl_CountdownShow.Text <> "OFF" Then
                lbl_CountdownShow.Text = "OFF"
            End If
        Else
            If DisableCounter >= DisableTime Then
                DisableCounter = DisableTime
                DisableAll()
            End If
            lbl_CountdownShow.Text = (DisableTime - DisableCounter).ToString("0")
            DisableCounter += 0.1F
        End If
    End Sub

    Private Sub EnableAll()
        If Not KeyboardEnabled Then
            KeyboardEnabled = True
            MouseEnabled = True
            sysTrayIcon.Icon = My.Resources.Watchdog3
            Form2.Hide()
        End If
    End Sub

    Private Sub DisableAll()
        If TestEnableMethods() = False Then Return

        If KeyboardEnabled Then

            ' ------------------------------------ workaround for timeout mouse disabled 
            Mouse_OnOff.ReleaseMouseHook()
            Mouse_OnOff.SetMouseHook()
            'Keyboard_OnOff.ReleaseKeyboardHook()
            'Keyboard_OnOff.SetKeyboardHook()
            ' --------------------------------------------------------------------------


            ' -------------------------------------------------- Disable Keyboard and Mouse
            KeyboardEnabled = False
            MouseEnabled = False
            ' -------------------------------------------------- Sys Tray Icon
            sysTrayIcon.Icon = My.Resources.WatchdogLocked
            If chk_NoMessages.Checked = False Then
                sysTrayIcon.ShowBalloonTip(6000, _
                                           "Keyboard and mouse are locked", _
                                           "To unlock press the password keys," & vbCr & _
                                           "or use the mouse button sequence," & vbCr & _
                                           "or click on the dog nose.", _
                                           ToolTipIcon.Info)
            End If
            ' -------------------------------------------------- Prepare Form2
            If chk_ShowPasswords.Checked Then
                Form2.lbl_Password.Text = txt_Password.Text
                Form2.lbl_MouseSequence.Text = txt_MouseSequence.Text
            Else
                Form2.lbl_Password.Text = ""
                Form2.lbl_MouseSequence.Text = ""
            End If
            ' -------------------------------------------------- Show Form2
            Form2.Activate()
           
            If chk_CoverEntireScreen.Checked Then
                Form2.Opacity = 0.35
                'Form2.BackColor = Color.FromArgb(50, 100, 200)
                'Form2.BackColor = Color.DarkBlue
                'Form2.BackColor = Color.DarkSlateBlue
                Form2.BackColor = Color.Azure
                Form2.Width = GetAllScreensRectangle.Width
                Form2.Height = GetAllScreensRectangle.Height
            Else
                Form2.Opacity = 0.8
                'Form2.BackColor = Color.FromArgb(50, 100, 200)
                'Form2.BackColor = Color.DarkBlue
                Form2.BackColor = Color.DarkSlateBlue
                Form2.TransparencyKey = Color.DarkSlateBlue
                'Form2.BackColor = Color.Azure
                Form2.Width = Form2.PictureBox1.Width
                Form2.Height = Form2.PictureBox1.Height
                If chk_ShowPasswords.Checked Then
                    Form2.Width += 15
                    Form2.Height += 75
                End If
            End If
            Form2.Left = GetAllScreensRectangle.Width - Form2.Width
            Form2.Top = GetAllScreensRectangle.Height - Form2.Height
            Form2.Show()
            ' -------------------------------------------------- DogNose position
            If chk_EnableNose.Checked Then
                Mouse_OnOff.EnablePoint = New Point(Form2.Left + Form2.Width - 154, _
                                                    Form2.Top + Form2.Height - 95)
                Mouse_OnOff.EnablePointRadius = 23
                If PointDistance(Cursor.Position, Mouse_OnOff.EnablePoint) < 200 Then
                    Cursor.Position = New Point(Form2.Width \ 2, Form2.Height \ 2)
                End If
            Else
                Mouse_OnOff.EnablePoint = New Point(-99999, -99999)
            End If
        End If
    End Sub


End Class
